



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>浅析Web API中FromBody属性</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">浅析Web API中FromBody属性</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-03-30 00:02:10 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p><strong>比较如下两段代码及测试结果：</strong></p>
<div>
<pre class="prettyprint linenums">public class ValuesController : ApiController<br />
{<br />
    // POST api/&lt;controller&gt;<br />
    public string Post(string value)<br />
    {<br />
        return value;<br />
    }<br />
}</pre>
</div>
<p>用swagger ui请求时，value的值为&ldquo;1&rdquo;或&ldquo;a&ldquo;均可返回。</p>
<div>
<pre class="prettyprint linenums">public class ValuesController : ApiController<br />
{<br />
    // POST api/&lt;controller&gt;<br />
    public string Post(<strong>[FromBody]</strong>string value)<br />
    {<br />
        return value;<br />
    }<br />
}</pre>
</div>
<p>用swagger ui请求时，value的值为&ldquo;1&rdquo;可正确返回，但为&ldquo;a&rdquo;时返回值为null。</p>
<p><strong>怎么回事？</strong><br />显然有必要了解一下FromBody特性，见如下mscor描述。通俗点说，FromBodyAttribute要求被其修饰的参数，必须是序列化后的实体成员。<br />显然&ldquo;a&rdquo;不是序列化后的json串，而&ldquo;"a"&rdquo;才是。<br />那么，&ldquo;1&rdquo;与&ldquo;"1"&rdquo;为什么都可以呢？这是一个技术细节，我们知道，在一个实体里如果定义了数值类型的属性，则在将这个实体的对象序列化后，它的这些数值参数默认是带双引号的。而实际上，将这些数值参数的双引号去掉，同样是一个有效的json串。所以，不难理解，&ldquo;1&rdquo;与&ldquo;"1"&rdquo;是等效的json串。</p>
<div>
<pre class="prettyprint linenums">#region 程序集 System.Web.Http.dll, v4.0.0.0<br />
// D:\SourceProject\yi+.gateway\branches\trunkOLd\packages\Microsoft.AspNet.WebApi.Core.4.0.30506.0\lib\net40\System.Web.Http.dll<br />
#endregion

using System;<br />
using System.Web.Http.Controllers;

namespace System.Web.Http<br />
{<br />
    // 摘要:<br />
    //<strong>     一个特性，该特性指定操作参数仅来自传入 System.Net.Http.HttpRequestMessage 的实体正文。</strong><br />
    [AttributeUsage(AttributeTargets.Class | AttributeTargets.Parameter, Inherited = true, AllowMultiple = false)]<br />
    public sealed class FromBodyAttribute : ParameterBindingAttribute<br />
    {<br />
        // 摘要:<br />
        //     初始化 System.Web.Http.FromBodyAttribute 类的新实例。<br />
        public FromBodyAttribute();

        // 摘要:<br />
        //     获取参数绑定。<br />
        //<br />
        // 参数:<br />
        //   parameter:<br />
        //     参数说明。<br />
        //<br />
        // 返回结果:<br />
        //     参数绑定。<br />
        public override HttpParameterBinding GetBinding(HttpParameterDescriptor parameter);<br />
    }<br />
}</pre>
</div>
<p><strong>最后，贴上两种情况下swagger ui的页面请求截图：</strong></p>
<p><strong><img referrerpolicy="no-referrer"src="https://images2015.cnblogs.com/blog/202192/201703/202192-20170313205621260-1705618551.png" /><img referrerpolicy="no-referrer"src="https://images2015.cnblogs.com/blog/202192/201703/202192-20170313205643760-1304683016.png" /></strong></p>
<p>通过比较可以看到，两者的请求参数类型、curl和Request URL是有区别的：<br />【value参数无FromBody特性的】<br />value的Type是：query<br />Curl：curl -X POST --header 'Accept: application/json' 'http://localhost:36024/api/Values?value=a'<br />Request URL：http://localhost:36024/api/Values?value=a<br />【value参数有FromBody特性的】<br />value的Type是：body。这时需要选择Parameter content type，默认是application/json<br />Curl：curl -X POST --header 'Content-Type: application/json' --header 'Accept: text/json' -d 'a' 'http://localhost:36024/api/Values'<br />Request URL：http://localhost:36024/api/Values</p>
<p>webapi默认返回的是json格式的字符串。从swagger ui的响应域的标签&ldquo;Response Body&rdquo;（不是Response Value）可以看出来，为swagger的细节点赞！</p>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/e9jekdg8.html">iOS 常用的向上&comma;向下取整&comma; 四舍五入函数</a>
		</li>
						<li><a href="https://www.batexi.com/a/4951d6eq.html">C&num; DataGrid合并单元格</a>
		</li>
						<li><a href="https://www.batexi.com/a/49g73o09.html">指针的指针&amp;amp&semi;指向指针数组的指针</a>
		</li>
						<li><a href="https://www.batexi.com/a/qvvej1xq.html">PHP四大安全策略</a>
		</li>
						<li><a href="https://www.batexi.com/a/qvvjxdyq.html">poj 2777 Count Color&lpar;线段树&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/qxng2008.html">Windows玩转Docker&lpar;二&rpar;：运行whalesay image</a>
		</li>
						<li><a href="https://www.batexi.com/a/qde45379.html">【Linux】鸟哥的Linux私房菜基础学习篇整理（二）</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1zeve59.html">HTML5添加背景音乐</a>
		</li>
						<li><a href="https://www.batexi.com/a/9rdok748.html">java改变图片文件尺寸</a>
		</li>
						<li><a href="https://www.batexi.com/a/8z1m06n9.html">&lbrack;一个经典的多线程同步问题&rsqb;解决方案二：Event事件</a>
		</li>
						<li><a href="https://www.batexi.com/a/qn1rm628.html">JS中String的反转函数</a>
		</li>
						<li><a href="https://www.batexi.com/a/qv1vl61q.html">50 tips of JavaScript</a>
		</li>
						<li><a href="https://www.batexi.com/a/qxknpxd8.html">PHP实现插入排序算法</a>
		</li>
						<li><a href="https://www.batexi.com/a/8mep7g2q.html">js原生的轮播图</a>
		</li>
						<li><a href="https://www.batexi.com/a/93yk3on8.html">jquery 图片自动无缝滚动</a>
		</li>
						<li><a href="https://www.batexi.com/a/960p7749.html">V-REP与C&plus;&plus;初步通信测试</a>
		</li>
						<li><a href="https://www.batexi.com/a/q7ojdpe8.html">Thymeleaf学习记录（1）--启动模板及建立Demo</a>
		</li>
						<li><a href="https://www.batexi.com/a/90r06rm9.html">安装astrixx firefox插件</a>
		</li>
						<li><a href="https://www.batexi.com/a/qll4pr6q.html">Java中的国际化</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwloy539.html">消息通讯之关于消息队列MQ必须了解的相关概念</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/q25136vq.html">&lbrack;No000014D&rsqb;chrome console 调试 引入 jquery等外部库</a>
			</li>
						<li><a href="https://www.batexi.com/a/8kjzrn59.html">manifold 微分流形上可以定义可微函数、切向量、切向量场、各种张量场等对象并建立其上的分析学，并可以赋予更复杂的几何结构以研究它们的性质。</a>
			</li>
						<li><a href="https://www.batexi.com/a/qv2w3zj9.html">Canonical form</a>
			</li>
						<li><a href="https://www.batexi.com/a/9r5lkwdq.html">如何实现浏览器向服务器伪造refer？</a>
			</li>
						<li><a href="https://www.batexi.com/a/9j17d7g9.html">Android Studio自动排版的两种方法</a>
			</li>
						<li><a href="https://www.batexi.com/a/9pw56jy8.html">洛谷P3158 放棋子 &lbrack;CQOI2011&rsqb; dp&plus;数论</a>
			</li>
						<li><a href="https://www.batexi.com/a/q251ezlq.html">CentOS安装HBase</a>
			</li>
						<li><a href="https://www.batexi.com/a/qdwv1nx9.html">NOIP国王游戏</a>
			</li>
						<li><a href="https://www.batexi.com/a/95g1l6mq.html">mvc，EntityFramework调用分页存储过程</a>
			</li>
						<li><a href="https://www.batexi.com/a/8o1rrleq.html">Erlang调度器</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
